diff --git a/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
similarity index 66%
rename from src/main/java/net/minecraft/core/block/Block.java
rename to game/core/src/main/java/net/minecraft/core/block/Block.java
index 3f0250c31..5976a3e3a 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -2,9 +2,6 @@ package net.minecraft.core.block;
 
 
 import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.LinkedHashMap;
-import java.util.Map;
 import java.util.Random;
 import java.util.function.Function;
 import java.util.function.Supplier;
@@ -18,8 +15,6 @@ import net.minecraft.core.util.helper.Direction;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import com.b100.utils.Utils;
-
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.material.Material;
@@ -52,18 +47,6 @@ import net.minecraft.core.world.WorldSource;
 public class Block
     implements ITaggable<Block>, IItemConvertible
 {
-    public static final @Nullable Block @NotNull [] blocksList = new Block[16384];
-    public static final Map<NamespaceID, Block> blockMap = new LinkedHashMap<>();
-    public static final boolean[] shouldTick = new boolean[blocksList.length];
-    public static final boolean[] solid = new boolean[blocksList.length];
-    public static final boolean[] isEntityTile = new boolean[blocksList.length];
-    public static final int[] lightBlock = new int[blocksList.length];
-    public static final boolean[] translucent = new boolean[blocksList.length];
-    public static final int[] lightEmission = new int[blocksList.length];
-    public static final boolean[] neighborNotifyOnMetadataChangeDisabled = new boolean[blocksList.length];
-    public static final Map<String, Integer> keyToIdMap = new HashMap<>();
-    public static int highestBlockId = 0;
-
     public final int id;
     public final NamespaceID namespaceID;
     protected float blockHardness;
@@ -71,17 +54,11 @@ public class Block
     protected boolean blockConstructorCalled;
     protected boolean enableStats;
     protected boolean isLitInteriorSurface;
-    public double minX;
-    public double minY;
-    public double minZ;
-    public double maxX;
-    public double maxY;
-    public double maxZ;
+    protected final AABB bounds = AABB.getPermanentBB(0, 0, 0, 1, 1, 1);
     public float blockParticleGravity;
     public final Material blockMaterial;
     public float friction;
     protected String key;
-    public int dropOverride = -1;
     public boolean immovable = false;
     public MaterialColor overrideColor;
     private BlockSound blockSound = BlockSounds.DEFAULT;
@@ -104,29 +81,30 @@ public class Block
             throw new IllegalArgumentException(e);
         }
 
-        if(blocksList[id] != null) {
-            throw new IllegalArgumentException("Block slot '" + id + "' is already occupied by '" + blocksList[id] + "' when adding " + this);
+        if(Blocks.blocksList[id] != null) {
+            throw new IllegalArgumentException("Block slot '" + id + "' is already occupied by '" + Blocks.blocksList[id] + "' when adding " + this);
         }
-        if (blockMap.containsKey(this.namespaceID)){
-            throw new IllegalArgumentException("Block id '" + namespaceID + "' is already used by '" + blockMap.get(this.namespaceID) + "' when adding " + this);
+        if (Blocks.blockMap.containsKey(this.namespaceID)){
+            throw new IllegalArgumentException("Block id '" + namespaceID + "' is already used by '" + Blocks.blockMap.get(this.namespaceID) + "' when adding " + this);
         }
 
         blockMaterial = material;
-        blocksList[id] = this;
-        blockMap.put(this.namespaceID, this);
+        Blocks.blocksList[id] = this;
+        Blocks.blockMap.put(this.namespaceID, this);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-        solid[id] = isSolidRender();
-        lightBlock[id] = (isSolidRender() || blocksLight()) ? 255 : 0;
-        translucent[id] = !material.blocksLight();
-        isEntityTile[id] = false;
-        setKey(translationKey);
+        Blocks.solid[id] = isSolidRender();
+        Blocks.lightBlock[id] = (isSolidRender() || blocksLight()) ? 255 : 0;
+        Blocks.translucent[id] = !material.blocksLight();
+        Blocks.isEntityTile[id] = false;
+        this.key = "tile." + translationKey;
+        Blocks.keyToIdMap.put(this.key, this.id);
 
-        if (highestBlockId < id) highestBlockId = id;
+        if (Blocks.highestBlockId < id) Blocks.highestBlockId = id;
     }
 
 	public Block withDisabledNeighborNotifyOnMetadataChange()
     {
-        neighborNotifyOnMetadataChangeDisabled[id] = true;
+        Blocks.neighborNotifyOnMetadataChangeDisabled[id] = true;
         return this;
     }
 
@@ -136,18 +114,18 @@ public class Block
 
     public Block withLightBlock(int blockAmount)
     {
-        lightBlock[id] = blockAmount;
+        Blocks.lightBlock[id] = blockAmount;
         return this;
     }
     public Block withLightEmission(float lightEmission)
     {
-        Block.lightEmission[id] = (int)(15F * lightEmission);
+        Blocks.lightEmission[id] = (int)(15F * lightEmission);
         return this;
     }
 
     public Block withLightEmission(int lightEmission)
     {
-        Block.lightEmission[id] = lightEmission & 0x0F;
+        Blocks.lightEmission[id] = lightEmission & 0x0F;
         return this;
     }
 
@@ -209,12 +187,6 @@ public class Block
         return this;
     }
 
-    public Block setDropOverride(int dropId)
-    {
-    	dropOverride = dropId;
-    	return this;
-    }
-
     public Block withLitInteriorSurface(boolean isLit)
     {
         isLitInteriorSurface = isLit;
@@ -268,26 +240,29 @@ public class Block
 
     public Block setTicking(boolean tick)
     {
-        Block.shouldTick[id] = tick;
+        Blocks.shouldTick[id] = tick;
         return this;
     }
 
-    public void setBlockBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
+    protected void setBlockBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
     {
-        this.minX = minX;
-        this.minY = minY;
-        this.minZ = minZ;
-        this.maxX = maxX;
-        this.maxY = maxY;
-        this.maxZ = maxZ;
+        bounds.set(minX, minY, minZ, maxX, maxY, maxZ);
+    }
+
+    public AABB getBounds() {
+        return bounds.copy();
+    }
+
+    public AABB getBoundsRaw() {
+        return bounds;
     }
 
 	public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z) {
-		return blockAccess.getBrightness(x, y, z, lightEmission[id]);
+		return blockAccess.getBrightness(x, y, z, Blocks.lightEmission[id]);
 	}
 
 	public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
-		return blockAccess.getLightmapCoord(x, y, z, lightEmission[id]);
+		return blockAccess.getLightmapCoord(x, y, z, Blocks.lightEmission[id]);
 	}
 
 	/**
@@ -297,44 +272,6 @@ public class Block
 		return isSolidRender() ? 1.0f : 0.0f;
 	}
 
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
-    {
-    	Side side1 = Side.getSideById(side);
-        if(side1 == Side.BOTTOM && minY > 0.0D)
-        {
-            return true;
-        }
-        else if(side1 == Side.TOP && maxY < 1.0D)
-        {
-            return true;
-        }
-        else if(side1 == Side.NORTH && minZ > 0.0D)
-        {
-            return true;
-        }
-        else if(side1 == Side.SOUTH && maxZ < 1.0D)
-        {
-            return true;
-        }
-        else if(side1 == Side.WEST && minX > 0.0D)
-        {
-            return true;
-        }
-        else if(side1 == Side.EAST && maxX < 1.0D)
-        {
-            return true;
-        }
-        else
-        {
-            return !blockAccess.isBlockOpaqueCube(x, y, z);
-        }
-    }
-
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side, int meta)
-    {
-        return shouldSideBeRendered(blockAccess, x, y, z, side);
-    }
-
     public boolean getIsBlockSolid(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return blockAccess.getBlockMaterial(x, y, z).isSolid();
@@ -342,7 +279,7 @@ public class Block
 
     public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        return AABB.getTemporaryBB((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
+        return getBlockBoundsFromState(world, x, y, z).move(x, y, z);
     }
 
     public BoundingVolume getBoundingVolume(World world, int x, int y, int z)
@@ -352,10 +289,13 @@ public class Block
 
     public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
     {
-        AABB aabbFromPool = getCollisionBoundingBoxFromPool(world, x, y, z);
-        if(aabbFromPool != null && aabb.intersects(aabbFromPool))
+        addIntersectingBoundingBox(aabb, getCollisionBoundingBoxFromPool(world, x, y, z), aabbList);
+    }
+
+    protected void addIntersectingBoundingBox(AABB sourceAABB, AABB aabbToAdd, ArrayList<AABB> aabbList) {
+        if(aabbToAdd != null && sourceAABB.intersects(aabbToAdd))
         {
-            aabbList.add(aabbFromPool);
+            aabbList.add(aabbToAdd);
         }
     }
 
@@ -366,7 +306,7 @@ public class Block
 
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        return AABB.getTemporaryBB((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
+        return getBlockBoundsFromState(world, x, y, z).move(x, y, z);
     }
     public MaterialColor getMaterialColor(){
         if (overrideColor != null) return overrideColor;
@@ -456,90 +396,73 @@ public class Block
         return blastResistance / 5F;
     }
 
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end, boolean useSelectorBoxes)
     {
-        setBlockBoundsBasedOnState(world, x, y, z);
+        AABB bounds = useSelectorBoxes ? getSelectedBoundingBoxFromPool(world, x, y, z).move(-x, -y, -z) : getBlockBoundsFromState(world, x, y, z);
         start = start.add(-x, -y, -z);
         end = end.add(-x, -y, -z);
-		Vec3 vec32 = start.clipX(end, minX);
-		Vec3 vec3d3 = start.clipX(end, maxX);
-		Vec3 vec34 = start.clipY(end, minY);
-		Vec3 vec35 = start.clipY(end, maxY);
-		Vec3 vec36 = start.clipZ(end, minZ);
-		Vec3 vec37 = start.clipZ(end, maxZ);
-
-		if(!isVecInsideYZBounds(vec32)) vec32 = null;
-		if(!isVecInsideYZBounds(vec3d3)) vec3d3 = null;
-		if(!isVecInsideXZBounds(vec34)) vec34 = null;
-		if(!isVecInsideXZBounds(vec35)) vec35 = null;
-		if(!isVecInsideXYBounds(vec36)) vec36 = null;
-		if(!isVecInsideXYBounds(vec37)) vec37 = null;
+		Vec3 minVX = start.clipX(end, bounds.minX);
+		Vec3 maxVX = start.clipX(end, bounds.maxX);
+		Vec3 minVY = start.clipY(end, bounds.minY);
+		Vec3 maxVY = start.clipY(end, bounds.maxY);
+		Vec3 minVZ = start.clipZ(end, bounds.minZ);
+		Vec3 maxVZ = start.clipZ(end, bounds.maxZ);
+
+		if(!isVecInsideYZBounds(bounds,minVX)) minVX = null;
+		if(!isVecInsideYZBounds(bounds,maxVX)) maxVX = null;
+		if(!isVecInsideXZBounds(bounds,minVY)) minVY = null;
+		if(!isVecInsideXZBounds(bounds,maxVY)) maxVY = null;
+		if(!isVecInsideXYBounds(bounds,minVZ)) minVZ = null;
+		if(!isVecInsideXYBounds(bounds,maxVZ)) maxVZ = null;
 
 		Vec3 vec38 = null;
-		if(vec32 != null && (vec38 == null || start.distanceToSquared(vec32) < start.distanceToSquared(vec38))) vec38 = vec32;
-		if(vec3d3 != null && (vec38 == null || start.distanceToSquared(vec3d3) < start.distanceToSquared(vec38))) vec38 = vec3d3;
-		if(vec34 != null && (vec38 == null || start.distanceToSquared(vec34) < start.distanceToSquared(vec38))) vec38 = vec34;
-		if(vec35 != null && (vec38 == null || start.distanceToSquared(vec35) < start.distanceToSquared(vec38))) vec38 = vec35;
-		if(vec36 != null && (vec38 == null || start.distanceToSquared(vec36) < start.distanceToSquared(vec38))) vec38 = vec36;
-		if(vec37 != null && (vec38 == null || start.distanceToSquared(vec37) < start.distanceToSquared(vec38))) vec38 = vec37;
+		if(minVX != null && (vec38 == null || start.distanceToSquared(minVX) < start.distanceToSquared(vec38))) vec38 = minVX;
+		if(maxVX != null && (vec38 == null || start.distanceToSquared(maxVX) < start.distanceToSquared(vec38))) vec38 = maxVX;
+		if(minVY != null && (vec38 == null || start.distanceToSquared(minVY) < start.distanceToSquared(vec38))) vec38 = minVY;
+		if(maxVY != null && (vec38 == null || start.distanceToSquared(maxVY) < start.distanceToSquared(vec38))) vec38 = maxVY;
+		if(minVZ != null && (vec38 == null || start.distanceToSquared(minVZ) < start.distanceToSquared(vec38))) vec38 = minVZ;
+		if(maxVZ != null && (vec38 == null || start.distanceToSquared(maxVZ) < start.distanceToSquared(vec38))) vec38 = maxVZ;
 
 		if(vec38 == null) return null;
 		Side side = Side.NONE;
-		if(vec38 == vec32) side = Side.WEST;
-		if(vec38 == vec3d3) side = Side.EAST;
-		if(vec38 == vec34) side = Side.BOTTOM;
-		if(vec38 == vec35) side = Side.TOP;
-		if(vec38 == vec36) side = Side.NORTH;
-		if(vec38 == vec37) side = Side.SOUTH;
+		if(vec38 == minVX) side = Side.WEST;
+		if(vec38 == maxVX) side = Side.EAST;
+		if(vec38 == minVY) side = Side.BOTTOM;
+		if(vec38 == maxVY) side = Side.TOP;
+		if(vec38 == minVZ) side = Side.NORTH;
+		if(vec38 == maxVZ) side = Side.SOUTH;
 
         return new HitResult(x, y, z, side, vec38.add(x, y, z));
     }
 
-    private boolean isVecInsideYZBounds(Vec3 vec3)
+    private boolean isVecInsideYZBounds(AABB bounds, @Nullable Vec3 vec3)
     {
-        if(vec3 == null)
-        {
+        if(vec3 == null) {
             return false;
         }
-        else
-        {
-            return vec3.y >= minY && vec3.y <= maxY && vec3.z >= minZ && vec3.z <= maxZ;
-        }
+        return vec3.y >= bounds.minY && vec3.y <= bounds.maxY && vec3.z >= bounds.minZ && vec3.z <= bounds.maxZ;
     }
 
-    private boolean isVecInsideXZBounds(Vec3 vec3)
+    private boolean isVecInsideXZBounds(AABB bounds, @Nullable Vec3 vec3)
     {
-        if(vec3 == null)
-        {
+        if(vec3 == null) {
             return false;
         }
-        else
-        {
-            return vec3.x >= minX && vec3.x <= maxX && vec3.z >= minZ && vec3.z <= maxZ;
-        }
+        return vec3.x >= bounds.minX && vec3.x <= bounds.maxX && vec3.z >= bounds.minZ && vec3.z <= bounds.maxZ;
     }
 
-    private boolean isVecInsideXYBounds(Vec3 vec3)
+    private boolean isVecInsideXYBounds(AABB bounds, @Nullable Vec3 vec3)
     {
-        if(vec3 == null)
-        {
+        if(vec3 == null) {
             return false;
         }
-        else
-        {
-            return vec3.x >= minX && vec3.x <= maxX && vec3.y >= minY && vec3.y <= maxY;
-        }
+        return vec3.x >= bounds.minX && vec3.x <= bounds.maxX && vec3.y >= bounds.minY && vec3.y <= bounds.maxY;
     }
 
     public void onBlockDestroyedByExplosion(World world, int x, int y, int z)
     {
     }
 
-    public int getRenderLayer()
-    {
-        return 0;
-    }
-
     public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side)
     {
         return canPlaceBlockAt(world, x, y, z);
@@ -569,12 +492,9 @@ public class Block
     public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
     }
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
-    }
-
-    public void setBlockBoundsBasedOnSide(WorldSource world, int x, int y, int z, Side side)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
+        return getBounds();
     }
 
     /**
@@ -645,32 +565,31 @@ public class Block
 			return;
 
 		ItemStack[] drops = getBreakResult(world, cause, x, y, z, meta, tileEntity);
-		if(dropOverride > 0) {
-			drops = new ItemStack[] { Item.itemsList[dropOverride].getDefaultStack() };
-		}
-		if(drops != null && drops.length > 0) {
-			for(ItemStack drop : drops) {
-				if(drop == null) {
-					continue;
-				}
-				if(hasTag(BlockTags.INSTANT_PICKUP) && player != null) {
-					player.inventory.insertItem(drop, true);
-					if(drop.stackSize <= 0) {
-						continue;
-					}
-				}
-				if(EntityItem.enableItemClumping) {
-					world.dropItem(x, y, z, drop.copy());
-				}else {
-					for(int i = 0; i < drop.stackSize; i++) {
-						ItemStack drop1 = drop.copy();
-						drop1.stackSize = 1;
-						world.dropItem(x, y, z, drop1);
-					}
-				}
-			}
-		}
-	}
+        if (drops == null) {
+            return;
+        }
+        for (int j = 0, dropsLength = drops.length; j < dropsLength; j++) {
+            ItemStack drop = drops[j];
+            if (drop == null) {
+                continue;
+            }
+            if (hasTag(BlockTags.INSTANT_PICKUP) && player != null) {
+                player.inventory.insertItem(drop, true);
+                if (drop.stackSize <= 0) {
+                    continue;
+                }
+            }
+            if (EntityItem.enableItemClumping) {
+                world.dropItem(x, y, z, drop.copy());
+            } else {
+                for (int i = 0; i < drop.stackSize; i++) {
+                    ItemStack drop1 = drop.copy();
+                    drop1.stackSize = 1;
+                    world.dropItem(x, y, z, drop1);
+                }
+            }
+        }
+    }
 
     public ISupport getSupport(World world, int x, int y, int z, Side side) {
         return FullSupport.INSTANCE;
@@ -689,12 +608,6 @@ public class Block
 
     }
 
-    public void setKey(String key)
-    {
-        this.key = "tile." + key;
-        keyToIdMap.put(this.key, this.id);
-    }
-
     public String getKey()
     {
         return key;
@@ -734,17 +647,17 @@ public class Block
     public static boolean isBuried (World world, int x, int y, int z)
     {
         boolean buried = true;
-        if(Block.lightBlock[world.getBlockId(x + 1, y, z)] <= 2)
+        if(Blocks.lightBlock[world.getBlockId(x + 1, y, z)] <= 2)
             buried = false;
-        if(Block.lightBlock[world.getBlockId(x - 1, y, z)] <= 2)
+        if(Blocks.lightBlock[world.getBlockId(x - 1, y, z)] <= 2)
             buried = false;
-        if(Block.lightBlock[world.getBlockId(x, y, z + 1)] <= 2)
+        if(Blocks.lightBlock[world.getBlockId(x, y, z + 1)] <= 2)
             buried = false;
-        if(Block.lightBlock[world.getBlockId(x, y, z - 1)] <= 2)
+        if(Blocks.lightBlock[world.getBlockId(x, y, z - 1)] <= 2)
             buried = false;
-        if(Block.lightBlock[world.getBlockId(x, y + 1, z)] <= 2)
+        if(Blocks.lightBlock[world.getBlockId(x, y + 1, z)] <= 2)
             buried = false;
-        if(Block.lightBlock[world.getBlockId(x, y - 1, z)] <= 2)
+        if(Blocks.lightBlock[world.getBlockId(x, y - 1, z)] <= 2)
             buried = false;
         return buried;
     }
@@ -752,7 +665,7 @@ public class Block
     public static boolean getIsLitInteriorSurface (World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y, z);
-        return l != 0 && blocksList[l] != null && blocksList[l].isLitInteriorSurface;
+        return l != 0 && Blocks.blocksList[l] != null && Blocks.blocksList[l].isLitInteriorSurface;
     }
 
     @SafeVarargs
@@ -774,7 +687,7 @@ public class Block
     public static boolean hasTag(int id, Tag<Block> tag)
     {
         if (id < 0) return false;
-        Block block = blocksList[id];
+        Block block = Blocks.blocksList[id];
         if (block == null) return false;
         return block.hasTag(tag);
     }
@@ -783,31 +696,6 @@ public class Block
     	return false;
     }
 
-    @Nullable
-    public static Block getBlock(int id)
-    {
-    	return blocksList[Math.max(id, 0)];
-    }
-
-    public static Block getBlockByName(String name)
-    {
-    	Utils.requireNonNull(name);
-    	if(name.startsWith("tile.")) {
-    		name = name.substring(5);
-    	}
-        for (Block block : blocksList)
-        {
-            if (block != null)
-            {
-                String otherName = block.key.substring(5);
-                if (name.equalsIgnoreCase(otherName))
-                {
-                    return block;
-                }
-            }
-        }
-    	return null;
-    }
     @NotNull
     public Supplier<Item> blockItemSupplier = () -> new ItemBlock(this);
 
diff --git a/src/main/java/net/minecraft/core/block/BlockBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockBed.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockBed.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockBed.java
index a66ddef1d..7d3054006 100644
--- a/src/main/java/net/minecraft/core/block/BlockBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockBed.java
@@ -9,6 +9,7 @@ import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -17,7 +18,7 @@ public class BlockBed extends Block {
 
 	public BlockBed(String key, String namespaceId, int id) {
 		super(key, namespaceId, id, Material.wood);
-		setBounds();
+		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.5625F, 1.0F);
 	}
 
 	@Override
@@ -90,11 +91,6 @@ public class BlockBed extends Block {
 		return false;
 	}
 
-	@Override
-	public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
-		setBounds();
-	}
-
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
 		int metadata = world.getBlockMetadata(x, y, z);
@@ -108,10 +104,6 @@ public class BlockBed extends Block {
 		}
 	}
 
-	private void setBounds() {
-		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.5625F, 1.0F);
-	}
-
 	@Override
 	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
 	{
diff --git a/src/main/java/net/minecraft/core/block/BlockBrazier.java b/game/core/src/main/java/net/minecraft/core/block/BlockBrazier.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/BlockBrazier.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockBrazier.java
index b33eed6d2..24040cd72 100644
--- a/src/main/java/net/minecraft/core/block/BlockBrazier.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockBrazier.java
@@ -82,7 +82,7 @@ public class BlockBrazier
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         if (!burning) return;
-        Block block = Block.blocksList[blockId];
+        Block block = Blocks.blocksList[blockId];
         if (block instanceof BlockFluid) {
             world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id, 0);
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockButton.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/BlockButton.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockButton.java
index c3edb56b6..5477ba41b 100644
--- a/src/main/java/net/minecraft/core/block/BlockButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockButton.java
@@ -206,7 +206,8 @@ public class BlockButton extends Block
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
         boolean invalid;
-        int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        int meta = world.getBlockMetadata(x, y, z);
+        int side = meta & MASK_DIRECTION;
         switch (side) {
             case SIDE_WEST:
                 invalid = !world.isBlockNormalCube(x - 1, y, z);
@@ -227,7 +228,7 @@ public class BlockButton extends Block
                 invalid = !world.isBlockNormalCube(x, y - 1, z);
                 break;
             default:
-                invalid = true;
+                invalid = false;
         }
         if(invalid)
         {
@@ -237,7 +238,7 @@ public class BlockButton extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
         int direction = meta & MASK_DIRECTION;
@@ -252,24 +253,19 @@ public class BlockButton extends Block
         }
         switch (direction) {
             case SIDE_WEST:
-                setBlockBounds(0.0F, f, 0.5F - f2, f3, f1, 0.5F + f2);
-                break;
+                return AABB.getTemporaryBB(0.0F, f, 0.5F - f2, f3, f1, 0.5F + f2);
             case SIDE_EAST:
-                setBlockBounds(1.0F - f3, f, 0.5F - f2, 1.0F, f1, 0.5F + f2);
-                break;
+                return AABB.getTemporaryBB(1.0F - f3, f, 0.5F - f2, 1.0F, f1, 0.5F + f2);
             case SIDE_NORTH:
-                setBlockBounds(0.5F - f2, f, 0.0F, 0.5F + f2, f1, f3);
-                break;
+                return AABB.getTemporaryBB(0.5F - f2, f, 0.0F, 0.5F + f2, f1, f3);
             case SIDE_SOUTH:
-                setBlockBounds(0.5F - f2, f, 1.0F - f3, 0.5F + f2, f1, 1.0F);
-                break;
+                return AABB.getTemporaryBB(0.5F - f2, f, 1.0F - f3, 0.5F + f2, f1, 1.0F);
             case SIDE_TOP:
-                setBlockBounds(0.5f - f2, 1 - f3, f, 0.5f + f2, 1.0, f1);
-                break;
+                return AABB.getTemporaryBB(0.5f - f2, 1 - f3, f, 0.5f + f2, 1.0, f1);
             case SIDE_BOTTOM:
-                setBlockBounds(0.5f - f2, 0, f, 0.5f + f2, f3, f1);
-                break;
+                return AABB.getTemporaryBB(0.5f - f2, 0, f, 0.5f + f2, f3, f1);
         }
+        return super.getBlockBoundsFromState(world, x, y, z);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockCactus.java
similarity index 87%
rename from src/main/java/net/minecraft/core/block/BlockCactus.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockCactus.java
index dc0904cf2..a37b22b81 100644
--- a/src/main/java/net/minecraft/core/block/BlockCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockCactus.java
@@ -26,6 +26,8 @@ public class BlockCactus extends Block implements IBonemealable
     {
         super(key, namespaceId, id, Material.cactus);
         setTicking(true);
+        float f = 0.0625F;
+        setBlockBounds(f, 0, f, 1 - f, 1, 1 - f);
     }
     public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
@@ -65,21 +67,6 @@ public class BlockCactus extends Block implements IBonemealable
         }
     }
 
-
-    @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        float f = 0.0625F;
-        return AABB.getTemporaryBB((float) x + f, y, (float) z + f, (float)(x + 1) - f, (float)(y + 1) - f, (float)(z + 1) - f);
-    }
-
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        float f = 0.0625F;
-        return AABB.getTemporaryBB((float) x + f, y, (float) z + f, (float)(x + 1) - f, y + 1, (float)(z + 1) - f);
-    }
-
     @Override
 	public boolean isCubeShaped()
     {
@@ -150,7 +137,7 @@ public class BlockCactus extends Block implements IBonemealable
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
         {
-            ((BlockCactus)Block.blocksList[id]).growCactusOnTop(world, blockX, blockY, blockZ);
+            ((BlockCactus)Blocks.blocksList[id]).growCactusOnTop(world, blockX, blockY, blockZ);
             if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCake.java b/game/core/src/main/java/net/minecraft/core/block/BlockCake.java
new file mode 100644
index 000000000..485f4dc00
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockCake.java
@@ -0,0 +1,24 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockCake extends BlockEdible
+{
+
+	public BlockCake(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, 6, 3, () -> Items.FOOD_CAKE);
+    }
+
+    @Override
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
+    {
+        int l = world.getBlockMetadata(x, y, z);
+        float f = 0.0625F;
+        float f1 = (float)(1 + l * 2) / 16F;
+        float f2 = 0.5F;
+        return AABB.getTemporaryBB(f1, 0.0F, f, 1.0F - f, f2, 1.0F - f);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockChest.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/BlockChest.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockChest.java
index 4dee34beb..4dc99174e 100644
--- a/src/main/java/net/minecraft/core/block/BlockChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockChest.java
@@ -243,19 +243,19 @@ public class BlockChest extends BlockTileEntity implements IPaintable {
 		int bW = world.getBlockId(x - 1, y, z);
 		int bE = world.getBlockId(x + 1, y, z);
 		Direction direction = Direction.NORTH;
-		if(Block.solid[bN] && !Block.solid[bS])
+		if(Blocks.solid[bN] && !Blocks.solid[bS])
 		{
 			direction = Direction.SOUTH;
 		}
-		if(Block.solid[bS] && !Block.solid[bN])
+		if(Blocks.solid[bS] && !Blocks.solid[bN])
 		{
 			direction = Direction.NORTH;
 		}
-		if(Block.solid[bW] && !Block.solid[bE])
+		if(Blocks.solid[bW] && !Blocks.solid[bE])
 		{
 			direction = Direction.EAST;
 		}
-		if(Block.solid[bE] && !Block.solid[bW])
+		if(Blocks.solid[bE] && !Blocks.solid[bW])
 		{
 			direction = Direction.WEST;
 		}
@@ -270,7 +270,7 @@ public class BlockChest extends BlockTileEntity implements IPaintable {
 	}
 
 	public static boolean isChest(World world, int x, int y, int z) {
-		return Block.blocksList[world.getBlockId(x, y, z)] instanceof BlockChest;
+		return Blocks.blocksList[world.getBlockId(x, y, z)] instanceof BlockChest;
 	}
 	
 	public static boolean isSingleChest(World world, int x, int y, int z) {
